// license-header java merge-point
/* Autogenerated by AndroMDA (ManageableServiceLocator.vsl) - do not edit */
package org.andromda.test;

/**
 * Locates and provides all available application services.
 */
public class ManageableServiceLocator
{
    /**
     * The shared instance of this ServiceLocator.
     */
    private static ManageableServiceLocator instance;
    
    /**
     * The Context to lookup the service beans.
     */
    protected javax.naming.InitialContext context = null;

    /**
     * Cannot be instantiated constructor
     */
    private ManageableServiceLocator()
    {
        // shouldn't be instantiated
    }

    /**
     * Gets the shared instance of this Class.
     * Create it if it doesn't already exists, otherwise return the current instance.
     *
     * @return the shared service locator instance.
     */
    public static final ManageableServiceLocator instance()
    {
        if (instance == null)
        {
            instance = new ManageableServiceLocator();
        }
        return instance;
    }

    /**
     * Gets the InitialContext.
     * 
     * @param env the Context environment properties.
     * @return the javax.naming.InitialContext.
     * @throws javax.naming.NamingException failure to create InitialContext
     */
    protected synchronized javax.naming.InitialContext getContext(java.util.Properties env)
        throws javax.naming.NamingException
    {
        if (this.context == null)
        {
            this.context = new javax.naming.InitialContext(env);
        }
        return this.context;
    }

    /**
     * Instantiate a new InitialContext using the properties table.
     * 
     * @param env passed to the InitialContext constructor.
     * @return the javax.naming.InitialContext.
     * @throws javax.naming.NamingException failure to create InitialContext
     */
    protected synchronized javax.naming.InitialContext newContext(java.util.Properties env)
        throws javax.naming.NamingException
    {
        this.context = new javax.naming.InitialContext(env);
        return this.context;
    }

    /**
     * Shuts down the ManageableServiceLocator and releases any used resources.
     */
    public synchronized void shutdown()
    {
        if (this.context != null)
        {
            try
            {
                this.context.close();
            }
            catch (javax.naming.NamingException ne)
            {
                // ignore
            }
            finally
            {
                this.context = null;
            }
        }
    }

    /**
     * Gets an instance of {@link org.andromda.test.howto16.a.crud.PersonManageableService}.
     *
     * @throws javax.naming.NamingException failure to lookup remote manageable service interface.
     */
    public final org.andromda.test.howto16.a.crud.PersonManageableService getPersonManageableService()
        throws javax.naming.NamingException
    {
        return this.getPersonManageableServiceRemote(null);
    }

    /**
     * Get the remote interface for {@link org.andromda.test.howto16.a.crud.PersonManageableService}.
     *
     * @param env the Context environment properties.  Null represents no properties.
     * @throws javax.naming.NamingException failure to lookup remote manageable service interface.
     */
    public final org.andromda.test.howto16.a.crud.PersonManageableService getPersonManageableServiceRemote(java.util.Properties env)
        throws javax.naming.NamingException
    {
        return (org.andromda.test.howto16.a.crud.PersonManageableService)
            getContext(env).lookup("howtomodel-1.0-SNAPSHOT/PersonManageableService/remote");
    }
    
    /**
     * Get the local interface for {@link org.andromda.test.howto16.a.crud.PersonManageableService}.
     *
     * @param env the Context environment properties.  Null represents no properties.
     * @throws javax.naming.NamingException failure to lookup remote manageable service interface.
     */
    public final org.andromda.test.howto16.a.crud.PersonManageableService getPersonManageableServiceLocal(java.util.Properties env)
        throws javax.naming.NamingException
    {
        return (org.andromda.test.howto16.a.crud.PersonManageableService)
            getContext(env).lookup("howtomodel-1.0-SNAPSHOT/PersonManageableService/local");
    }
    /**
     * Gets an instance of {@link org.andromda.test.howto16.a.crud.CarManageableService}.
     *
     * @throws javax.naming.NamingException failure to lookup remote manageable service interface.
     */
    public final org.andromda.test.howto16.a.crud.CarManageableService getCarManageableService()
        throws javax.naming.NamingException
    {
        return this.getCarManageableServiceRemote(null);
    }

    /**
     * Get the remote interface for {@link org.andromda.test.howto16.a.crud.CarManageableService}.
     *
     * @param env the Context environment properties.  Null represents no properties.
     * @throws javax.naming.NamingException failure to lookup remote manageable service interface.
     */
    public final org.andromda.test.howto16.a.crud.CarManageableService getCarManageableServiceRemote(java.util.Properties env)
        throws javax.naming.NamingException
    {
        return (org.andromda.test.howto16.a.crud.CarManageableService)
            getContext(env).lookup("howtomodel-1.0-SNAPSHOT/CarManageableService/remote");
    }
    
    /**
     * Get the local interface for {@link org.andromda.test.howto16.a.crud.CarManageableService}.
     *
     * @param env the Context environment properties.  Null represents no properties.
     * @throws javax.naming.NamingException failure to lookup remote manageable service interface.
     */
    public final org.andromda.test.howto16.a.crud.CarManageableService getCarManageableServiceLocal(java.util.Properties env)
        throws javax.naming.NamingException
    {
        return (org.andromda.test.howto16.a.crud.CarManageableService)
            getContext(env).lookup("howtomodel-1.0-SNAPSHOT/CarManageableService/local");
    }

    /**
     * Gets an instance of the given service.
     *
     * @param serviceName lookup this service from the context.
     * @throws javax.naming.NamingException failure to lookup remote service interface.
     */
    public final Object getService(String serviceName)
        throws javax.naming.NamingException
    {
        return getService(serviceName, null);
    }

    /**
     * Gets an instance of the given service.
     *
     * @param serviceName lookup this service from the context.
     * @param env the Context environment properties.  Null represents no properties.
     * @throws javax.naming.NamingException failure to lookup remote service interface.
     */
    public final Object getService(String serviceName, java.util.Properties env)
        throws javax.naming.NamingException
    {
        return getContext(env).lookup(serviceName);
    }
}