// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SessionDaoBase.vsl in andromda-ejb3-cartridge.
//
package org.andromda.test.howto18.a;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import javax.annotation.Resource;
import javax.ejb.Local;
import javax.ejb.SessionContext;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 * <p>
 * Base EJB3 DAO Class: is able to create, update, remove, load, and find
 * objects of type <code>User</code>.
 * </p>
 *
 * @see UserDao
 */
@TransactionAttribute(TransactionAttributeType.REQUIRED)
@Local({UserDao.class})
public abstract class UserDaoBase
    implements UserDao
{
    // ------ Session Context Injection ------

    @Resource
    protected SessionContext context;

    // ------ Persistence Context Injection --------

    /**
     * Inject persistence context howtomodel
     */
    @PersistenceContext(unitName = "howtomodel")
    protected EntityManager emanager;

    /**
     * @see UserDao#load(int,)
     */
    public Object load(final int transform, final Long id)
        throws UserDaoException
    {
        if (id == null)
        {
            throw new IllegalArgumentException(
                "User.load - 'id' can not be null");
        }
        try
        {
            final Object entity = (User)emanager.find(User.class, id);
            return transformEntity(transform, (User)entity);
        }
        catch (Exception ex)
        {
            throw new UserDaoException(ex);
        }
    }

    /**
     * @see UserDao#load()
     */
    public User load( final Long id)
        throws UserDaoException
    {
        return (User)this.load(TRANSFORM_NONE, id);
    }

    /**
     * @see UserDao#loadAll()
     */
    @SuppressWarnings({"unchecked"})
    public Collection<User> loadAll()
        throws UserDaoException
    {
        return (Collection<User>)this.loadAll(TRANSFORM_NONE);
    }

    /**
     * @see UserDao#loadAll(int)
     */
    public Collection loadAll(final int transform)
        throws UserDaoException
    {
        try
        {
            Query query = emanager.createNamedQuery("User.findAll");
            List<User> results = query.getResultList();
            this.transformEntities(transform, results);
            return results;
        }
        catch (Exception ex)
        {
            throw new UserDaoException(ex);
        }
    }

    /**
     * @see UserDao#create(User)
     */
    public User create(User user)
        throws UserDaoException
    {
        return (User)this.create(TRANSFORM_NONE, user);
    }

    /**
     * @see UserDao#create(int transform, User)
     */
    public Object create(final int transform, final User user)
        throws UserDaoException
    {
        if (user == null)
        {
            throw new IllegalArgumentException(
                "User.create - 'user' can not be null");
        }

        try
        {
            emanager.persist(user);
            emanager.flush();
            return this.transformEntity(transform, user);
        }
        catch (Exception ex)
        {
            throw new UserDaoException(ex);
        }
    }

    /**
     * @see UserDao#create(Collection<User>)
     */
    @SuppressWarnings({"unchecked"})
    public Collection<User> create(final Collection<User> entities)
        throws UserDaoException
    {
        return create(TRANSFORM_NONE, entities);
    }

    /**
     * @see UserDao#create(int, Collection<User>)
     */
    @SuppressWarnings({"unchecked"})
    public Collection create(final int transform, final Collection<User> entities)
        throws UserDaoException
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "User.create - 'entities' can not be null");
        }
        Collection results = new ArrayList();
        try
        {
            for (final Iterator entityIterator = entities.iterator(); entityIterator.hasNext();)
            {
                results.add(create(transform, (User)entityIterator.next()));
            }
        }
        catch (Exception ex)
        {
            throw new UserDaoException(ex);
        }
        return results;
    }

    /**
     * @see UserDao#create(String)
     */
    public User create(
        String name)
        throws UserDaoException
    {
        return (User)this.create(TRANSFORM_NONE, name);
    }

    /**
     * @see UserDao#create(int, String)
     */
    public Object create(
        final int transform,
        String name)
        throws UserDaoException
    {
        User entity = new User();
        entity.setName(name);
        return this.create(transform, entity);
    }

    /**
     * @see UserDao#update(User)
     */
    public void update(User user)
        throws UserDaoException
    {
        if (user == null)
        {
            throw new IllegalArgumentException(
                "User.update - 'user' can not be null");
        }
        try
        {
            emanager.merge(user);
            emanager.flush();
        }
        catch (Exception ex)
        {
            throw new UserDaoException(ex);
        }
    }

    /**
     * @see UserDao#update(Collection<User>)
     */
    public void update(final Collection<User> entities)
        throws UserDaoException
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "User.update - 'entities' can not be null");
        }
        try
        {
            for (final Iterator entityIterator = entities.iterator(); entityIterator.hasNext();)
            {
                update((User)entityIterator.next());
            }
        }
        catch (Exception ex)
        {
            throw new UserDaoException(ex);
        }
    }

    /**
     * @see UserDao#remove(User)
     */
    public void remove(User user)
        throws UserDaoException
    {
        if (user == null)
        {
            throw new IllegalArgumentException(
                "User.remove - 'user' can not be null");
        }
        try
        {
            emanager.remove(user);
            emanager.flush();
        }
        catch (Exception ex)
        {
            throw new UserDaoException(ex);
        }
    }

    /**
     * @see UserDao#remove(Long)
     */
    public void remove(Long id)
        throws UserDaoException
    {
        if (id == null)
        {
            throw new IllegalArgumentException(
                "User.remove - 'id' can not be null");
        }
        try
        {
            final User entity = this.load(id);
            if (entity != null)
            {
                this.remove(entity);
            }
        }
        catch (Exception ex)
        {
            throw new UserDaoException(ex);
        }
    }

    /**
     * @see UserDao#remove(Collection<User>)
     */
    public void remove(Collection<User> entities)
        throws UserDaoException
    {
        if (entities == null)
        {
            throw new IllegalArgumentException(
                "User.remove - 'entities' can not be null");
        }
        try
        {
            for (final Iterator entityIterator = entities.iterator(); entityIterator.hasNext();)
            {
                remove((User)entityIterator.next());
            }
        }
        catch (Exception ex)
        {
            throw new UserDaoException(ex);
        }
    }

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>UserDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link UserDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    protected Object transformEntity(final int transform, final User entity)
    {
        Object target = null;
        if (entity != null)
        {
            switch (transform)
            {
                case TRANSFORM_NONE : // fall-through
                default:
                    target = entity;
            }
        }
        return target;
    }

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int, User)}
     * method. This method does not instantiate a new collection.
     * <p/>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>UserDao</code>
     * @param entities the collection of entities to transform
     * @return the same collection as the argument, but this time containing the transformed entities
     * @see #transformEntity(int, User)
     */
    protected void transformEntities(final int transform, final Collection entities)
    {
        switch (transform)
        {
            case TRANSFORM_NONE : // fall-through
                default:
                // do nothing;
        }
    }

}