// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: EntityEmbeddable.vsl in andromda-ejb3-cartridge.
//
package org.andromda.test.howto4.b;

import java.io.Serializable;
import java.util.Date;
import java.util.Set;
import java.util.TreeSet;
import javax.persistence.AttributeOverride;
import javax.persistence.AttributeOverrides;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Autogenerated POJO EJB class for Person containing the
 * bulk of the entity implementation.
 *
 * This is autogenerated by AndroMDA using the EJB3
 * cartridge.
 *
 * DO NOT MODIFY this class.
 *
 * 
 *
 */
@Entity
@Table(name = "PERSON")
@NamedQuery(name = "Person.findAll", query = "select person from Person AS person")
public class Person
    implements Serializable, Comparable<Person>
{

    private static final long serialVersionUID = -7166546957338809953L;

    // ----------- Attribute Definitions ------------

    private PersonPK pk;
    private String name;
    private Date birthDate;


    // --------- Relationship Definitions -----------

    private Set<Car> cars = new TreeSet<Car>();

    // ---- Manageable Display Attributes (Transient) -----


    // --------------- Constructors -----------------

    /**
     * Default empty constructor
     */
    public Person() {}

    /**
     * Implementation for the constructor with all POJO attributes except auto incremented identifiers.
     * This method sets all POJO fields defined in this class to the values provided by
     * the parameters.
     *
     * @param name Value for the name property
     * @param birthDate Value for the birthDate property
     */
    public Person(String name, Date birthDate)
    {
        setName(name);
        setBirthDate(birthDate);
    }

    /**
     * Constructor with all POJO attribute values and CMR relations.
     *
     * @param name Value for the name property
     * @param birthDate Value for the birthDate property
     * @param cars Value for the cars relation
     */
    public Person(String name, Date birthDate, Set<Car> cars)
    {
        setName(name);
        setBirthDate(birthDate);

        setCars(cars);
    }

    /**
     * Constructor with composite primary key arg only
     *
     * @param pk Composite primary key
     */
    public Person(PersonPK pk)
    {
        this.pk = pk;
    }


    // ----- Composite PK Accessors ------

    /**
     * Return the composite primary key for Person
     *
     * @return The composite primary key
     */
    @EmbeddedId
    @AttributeOverrides
    ({
        @AttributeOverride(name = "id", column = @Column(name = "ID", nullable = false)),
        @AttributeOverride(name = "tag", column = @Column(name = "TAG", nullable = false))
    })
    public PersonPK getPk()
    {
        return this.pk;
    }

    /**
     * Set the composite primary key for Person
     *
     * @param pk The composite primary key
     */
    public void setPk(PersonPK pk)
    {
        this.pk = pk;
    }


    // -------- Attribute Accessors ----------

    /**
     * Get the name property.
     * 
     * @return String The value of name
     */
    @Column(name = "NAME", nullable = false, insertable = true, updatable = true)
    public String getName()
    {
        return name;
    }

    /**
     * Set the name property.
     * @param value the new value
     */
    public void setName(String value)
    {
        this.name = value;
    }

    /**
     * Get the birthDate property.
     * 
     * @return Date The value of birthDate
     */
    @Column(name = "BIRTH_DATE", nullable = false, insertable = true, updatable = true)
    @Temporal(TemporalType.TIMESTAMP)
    public Date getBirthDate()
    {
        return birthDate;
    }

    /**
     * Set the birthDate property.
     * @param value the new value
     */
    public void setBirthDate(Date value)
    {
        this.birthDate = value;
    }


    // ------------- Relations ------------------

    /**
     * Get the cars Collection
     *
     * @return Set<Car>
     */
    @OneToMany(mappedBy = "owner")
    public Set<Car> getCars()
    {
        return this.cars;
    }

    /**
     * Set the cars
     *
     * @param cars
     */
    public void setCars (Set<Car> cars)
    {
        this.cars = cars;
    }

    // -------- Common Methods -----------

    /**
     * Indicates if the argument is of the same type and all values are equal.
     *
     * @param object The target object to compare with
     * @return boolean True if both objects a 'equal'
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Person))
        {
            return false;
        }
        final Person that = (Person)object;
        if (this.getPk().getId() != that.getPk().getId())
        {
            return false;
        }
        if (this.getPk().getTag() == null || that.getPk().getTag() == null || !this.getPk().getTag().equals(that.getPk().getTag()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code value for the object
     *
     * @return int The hash code value
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (int)this.getPk().getId();
        hashCode = 29 * hashCode + (this.getPk().getTag() == null ? 0 : this.getPk().getTag().hashCode());

        return hashCode;
    }

    /**
     * Returns a String representation of the object
     *
     * @return String Textual representation of the object displaying name/value pairs for all attributes
     */
    public String toString()
    {
        StringBuilder sb = new StringBuilder();
        sb.append("Person(=");
        sb.append("pk.id: ");
        sb.append(this.getPk().getId());
        sb.append(", pk.tag: ");
        sb.append(this.getPk().getTag());
        sb.append(", name: ");
        sb.append(getName());
        sb.append(", birthDate: ");
        sb.append(getBirthDate());
        sb.append(")");
        return sb.toString();
    }

    /**
     * @see Comparable#compareTo(T)
     */
    public int compareTo(Person o)
    {
        int cmp = 0;
        if (this.getPk() != null)
        {
            cmp = this.getPk().compareTo(o.getPk());
        }
        else
        {
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getBirthDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getBirthDate().compareTo(o.getBirthDate()));
            }
        }
        return cmp;
    }
}